import random

TILES = [[(0,0)], [(0,0),(1,0)], [(0,0),(0,1)], [(0,0),(0,1),(1,1)],
         [(0,0),(1,0),(1,1)], [(0,0),(1,0),(1,-1)], [(0,0),(0,1),(-1,1)],
         [(0,0),(1,0),(0,1),(1,1)],
         [(0,0),(0,1),(1,1),(1,2)],
         [(0,0),(1,0),(1,1),(2,1)],
         [(0,0),(1,0),(1,-1),(2,-1)],
         [(0,0),(0,1),(-1,1),(-1,2)],
         [(0,0),(1,0),(2,0)],
         [(0,0),(0,1),(0,2)],
         [(0,0),(0,1),(1,1),(2,1)],
         [(0,0),(1,0),(1,1),(1,2)],
         [(0,0),(1,0),(1,-1),(1,-2)],
         [(0,0),(0,1),(-1,1),(-2,1)]
        ]

def feasible(tiletype, tilepos, tiling):
    for p in tiletype:
        pos = (tilepos[0] + p[0], tilepos[1] + p[1])
        if pos[0] < 0 or pos[1] < 0 or pos[0] >= len(tiling) or pos[1] >= len(tiling[pos[0]]) or tiling[pos[0]][pos[1]] != 0:
            return False
    return True

def add_new_tile(ident, tilepos, tiling, tilelist):
    feasible_tiles = [t for t in TILES if feasible(t, tilepos, tiling)]
    if len(feasible_tiles) == 0:
        return False
    tiles = []
    for t in random.choice(feasible_tiles):
        tiling[tilepos[0]+t[0]][tilepos[1]+t[1]] = ident
        tiles.append((tilepos[0]+t[0], tilepos[1]+t[1]))
    tilelist.append(tiles)
    return True

def get_next_tile(tiling):
    for j in range(len(tiling[0])):
        for i in range(len(tiling)):
            if tiling[i][j] == 0:
                return (i,j)
    return None

def split_grid(sizex, sizey):
    repeat = True
    while repeat:
        repeat = False
        tiling = [[0 for y in range(sizey)] for x in range(sizex)]
        tilelist = []
        ident = 1
        next_tile = get_next_tile(tiling)
        while next_tile:
            ok = add_new_tile(ident, next_tile, tiling, tilelist)
            if ok:
                ident += 1
                next_tile = get_next_tile(tiling)
            else:
                # repeat = True
                assert(False)
    # for i in range(sizey):
    #     for j in range(sizex):
    #         print '%2d' % (tiling[j][i],),
    #     print
    return tiling, tilelist
